﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CollectionsSort
{
    class Car : IComparable<Car>
    {
        public string RegNo { get; set; }
        public string Model { get; set; }
        public int Year { get; set; }

        public Car(string regNo, string model, int year)
        {
            RegNo = regNo;
            Model = model;
            Year = year;
        }
        public int CompareTo(Car other)
        {
            if (other == null) return 1;
            return RegNo.CompareTo(other.RegNo);
        }

        public override string ToString()
        {
            return string.Format("RegNo: {0}, Model: {1}, Year: {2}", RegNo, Model, Year);
        }

        //protected bool Equals(Car other)
        //{
        //    return string.Equals(RegNo, other.RegNo) && string.Equals(Model, other.Model) && Year == other.Year;
        //}

        //public override bool Equals(object obj)
        //{
        //    if (ReferenceEquals(null, obj)) return false;
        //    if (ReferenceEquals(this, obj)) return true;
        //    if (obj.GetType() != this.GetType()) return false;
        //    return Equals((Car)obj);
        //}

        public override int GetHashCode()
        {
            unchecked
            {
                int hashCode = (RegNo != null ? RegNo.GetHashCode() : 0);
                hashCode = (hashCode*397) ^ (Model != null ? Model.GetHashCode() : 0);
                hashCode = (hashCode*397) ^ Year;
                return hashCode;
            }
        }
    }
}
